#if !defined(_SEModule_h_inc_)
#define _SEModule_h_inc_

#include <windows.h>
#include "SEModule_base.h"


class Module : public SEModule_base
{
public:
	Module(seaudioMasterCallback2 seaudioMaster, void *p_resvd1);
	~Module();

	void open();
    void close();
	static bool getModuleProperties (SEModuleProperties* properties);
	virtual bool getPinProperties (long index, SEPinProperties* properties);
	void SE_CALLING_CONVENTION sub_process(long buffer_offset, long sampleFrames );
	void OnPlugStateChange(SEPin *pin);


private:
    // pointer to circular buffer of samples
	float *output1_buffer;
    float *low_value, *high_value;
    float *pulse_width, *check_delay;
    int pw_count, pw_total;
    int cd_count, cd_total;
    char *name;
    char evtname[128];
    short mode;

    bool result;
    float rate;

    HANDLE evt;
};
#endif
