#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>


void usage(void)
    {
    printf("\n\nUsage: extevtsend [evtname] [actions]\n\n");
    printf("evtname - The name given to the event input in SynthEdit\n");
    printf("actions - One or more of the following commands\n");
    printf("\ts - Set the event\n");
    printf("\tr - Reset the event\n");
    printf("\td[value] - Delay for [value] milliseconds, 0 to 300,000\n\n");
    }

void main(int argc, char *argv[])
    {
    HANDLE evt;
    char name[128];
    int p, value;

    if(argc < 3)
        {
        usage();
        return;
        }

    strcpy(name, "SE_EXTEVT_IN_");
    strncat(name, argv[1], 128);
    name[127] = '\0';


    evt = OpenEvent(EVENT_MODIFY_STATE, FALSE, name);
    if(evt)
        {
        for(p = 2; p < argc; p++)
            {
            if(argv[p][0] == 's' || argv[p][0] == 'S')
                SetEvent(evt);
            else if(argv[p][0] == 'r' || argv[p][0] == 'R')
                ResetEvent(evt);
            else if(argv[p][0] == 'd' || argv[p][0] == 'D')
                {
                value = atoi(&argv[p][1]);
                if(value < 0)
                    value = 0;
                else if(value > 300,000)
                    value = 300,000;

                Sleep(value);
                }
            }
        }
    else
        {
        printf("Error - Invalid event name");
        }
    }