#ifndef __SEMod_struct_base_gui__
#define __SEMod_struct_base_gui__

#include "se_datatypes.h"
#include <windows.h>

#if PRAGMA_ALIGN_SUPPORTED || __MWERKS__
	#pragma options align=mac68k
#elif defined(MINGW) || defined(__GNUC__)
    #pragma pack(push,8)
#elif defined CBUILDER
    #pragma -a8
#elif defined(WIN32) || defined(__FLAT__)
	#pragma pack(push)
	#pragma pack(8)
#endif

#if defined(WIN32) || defined(__FLAT__) || defined CBUILDER
	#define SEMODCALLBACK __cdecl
#else
	#define SEMODCALLBACK
#endif

//---------------------------------------------------------------------------------------------
// misc def's
//---------------------------------------------------------------------------------------------

struct SEGUI_struct_base;
typedef	long (SEMODCALLBACK *seGuiCallback)(SEGUI_struct_base *effect, long opcode, long index,
		long value, void *ptr, float opt);

// the 'magic number' that identifies a SynthEdit module (spells SEPL)
//#define SepMagic 0x5345504C

//---------------------------------------------------------------------------------------------
//---------------------------------------------------------------------------------------------
struct SEGUI_struct_base
{
	long magic;			// magic number
	long version;
	long (SEMODCALLBACK *dispatcher)(SEGUI_struct_base *effect, long opCode, long index, long value,
		void *ptr, float opt);

	void *resvd1;		// reserved for host use, must be 0
	void *object;		// for class access 
	void *user;			// user access
	char future[16];	// pls zero
};

//---------------------------------------------------------------------------------------------
// Plugin Module opCodes (GUI)
//---------------------------------------------------------------------------------------------

enum
{
	seGuiInitialise = 0,		// initialise
	seGuiClose,			// exit, release all memory and other resources!
	seGuiPaint,
	seGuiLButtonDown,
	seGuiLButtonUp,
	seGuiMouseMove,
	seGuiOnModuleMessage,			// OnModuleMsg test
	seGuiOnGuiPlugValueChange,
	seGuiOnWindowOpen,
	seGuiOnWindowClose,
};

//---------------------------------------------------------------------------------------------
// Host opCodes (GUI)
//---------------------------------------------------------------------------------------------

enum
{
	seGuiHostRequestRepaint = 0,	//
	seGuiHostGetHandle,			//
	seGuiHostSendStringToAudio,			// SendStringToAudio test
	seGuiHostSetWindowSize,
	seGuiHostSetWindowSizeable,
	seGuiHostGetTotalPinCount,
	seGuiHostPlugSetValText,
	seGuiHostPlugGetValText,
	seGuiHostAddGuiPlug,
	seGuiRegisterPatchParameter,
	seGuiHostGetFontInfo,
	seGuiHostSetWindowType,
	seGuiHostGetWindowHandle,
	seGuiHostSetWindowFlags,
	seGuiHostPlugGetVal,
	seGuiHostPlugSetVal,
	seGuiHostPlugSetExtraData, // sets enum list or file extension (depending on datatype)
};

enum SEHostWindowFlags {HWF_RESIZEABLE=1, HWF_NO_CUSTOM_GFX_ON_STRUCTURE = 2};

// painting info
struct sepoint : public POINT
{
	sepoint(int px=0, int py=0){x=px;y=py;};
	sepoint(sepoint &other){x=other.x;y=other.y;};
};

struct SEWndInfo
{
	int width;
	int height;
	long context_handle;
};

struct SeFontInfo
{
	int size;
	int color;
	int color_background;
	int flags;  //alignment etc
	int font_height;
//	char category[20];
//	char facename[50];
	char future [100];
};

#if PRAGMA_ALIGN_SUPPORTED || __MWERKS__
	#pragma options align=reset
#elif defined(WIN32) || defined(__FLAT__)
	#pragma pack(pop)
#elif defined CBUILDER
	#pragma -a-
#endif

#endif	// __SEMod_struct_base_gui__
